" autodate.vim - Auto update date & time script
"
" Maintainer:	Taro Muraoka <koron@tka.att.ne.jp>
" Last change:	02:43:28 12-Mar-2000.
"
" ':source autodate.vim' and type "gts" at command mode.
"

let $adt_flag = 1

noremap gts :call AutoDateTime(1, 10, 'Last change:')<CR>
if has("autocmd")
  augroup AutoDateTime
    au!
    "autocmd FileWritePre * call AutoDateTime(10, 'Last change:')
    "autocmd BufUnload,FileWritePre,VimLeavePre * call AutoDateTime(1, 10, 'Last change:')
    "autocmd BufWritePre * call AutoDateTime(10, 'Last change:')
  augroup END
endif " has("autocmd")

"
" DateTimeString()
"   Generate date (and time) formated string. This is called back by
"   UpdateDateTime() function.
"
func! DateTimeString()
  return strftime('%H:%M:%S %d-' .
      \strpart('JanFebMarAprMayJunJulAugSepOctNovDec',
      \strftime('%m') * 3 - 3, 3) . '-%Y')
endfunc

"
" AutoDateTime(start, end, keyword)
"   Check a:keyword in from a:start line to a:end line of current buffer,
"   and modify date and time.
"
func! AutoDateTime(start, end, keyword)
"  if $adt_flag < 1 || !&modified | return | endif
  if a:start > a:end | return | endif
  let i = a:start
  let pat = a:keyword . '\(\s*\)[^.]*\.'
  let sub = a:keyword . '\1' . DateTimeString() . '.'
  while i <= a:end
    let str = getline(i)
    if str =~ pat
      call setline(i, substitute(str, pat, sub, ''))
    endif
    let i = i + 1
  endw
endfunc

" vi:ts=8 sts=2 sw=2 tw=0:
